# Simple Ultraleap

Understanding Ultraleap/Ultrahaptics/Leap Motion stuff

- [Leap Motion? Ultraleap?](#leap-motion-ultraleap)
- [API Compatibility](#api-compatibility)
- [OS Compatibility](#os-compatibility)
- [Hardware compatibility](#hardware-compatibility)
- [Programming languages support](#programming-languages-support)
- [Game engine supports](#game-engine-supports)

## Leap Motion? Ultraleap?

Leap Motion, created in 2013, was the company that created the original Leap Motion Controller and the hand tracking software. In 2019, it merged with Ultrahaptics, and the resulting company was renamed to Ultraleap. This page will still refer to some software version as "Leap Motion" as this how they are presented on the [Legacy downloads page](https://developer.leapmotion.com/releases) on the Ultraleap developer's website.

**If you're looking for the latest version of Ultraleap's hand tracking, [click on this link](https://developer.leapmotion.com/tracking-software-download)**

## API Compatibility

| Version         | Leap API           | LeapC API          | OpenXR                    |
| --------------- | ------------------ | ------------------ | ------------------------- |
| Leap Motion 2.x | :white_check_mark: | :x:                | :x:                       |
| Leap Motion 3.x | :white_check_mark: | :white_check_mark: | :x:                       |
| Leap Motion 4.x | :x:                | :white_check_mark: | :x:                       |
| Ultraleap 5.2+  | :x:                | :white_check_mark: | :white_check_mark:[¹] |

## OS Compatibility

| Version         | Windows            | MacOS              | Linux              | Android (XR2 only)     |
| --------------- | ------------------ | ------------------ | ------------------ | ---------------------- |
| Leap Motion 2.x | :white_check_mark: | :white_check_mark: | :white_check_mark: | :x:                    |
| Leap Motion 3.x | :white_check_mark: | :x:                | :x:                | :x:                    |
| Leap Motion 4.x | :white_check_mark: | :x:                | :x:                | :x:                    |
| Ultraleap 5.2+  | :white_check_mark: | :white_check_mark: | :white_check_mark: | :white_check_mark:[²] |

## Hardware compatibility

| Version         | Leap Motion Controller | SIR-170/3Di        | Leap Motion Controller 2 |
| --------------- | ---------------------- | ------------------ | ------------------------ |
| Leap Motion 2.x | :white_check_mark:     | :x:                | :x:                      |
| Leap Motion 3.x | :white_check_mark:     | :x:                | :x:                      |
| Leap Motion 4.x | :white_check_mark:     | :white_check_mark: | :x:                      |
| Ultraleap 5.2+  | :white_check_mark:[³] | :white_check_mark: | :white_check_mark:       |

## Programming languages support

This table won't take in account community-made bindings, **I will only list languages that are officially supported by Ultraleap**. Because language support is tied to which API is supported, we will list language support per API instead of per SDK version.

| Version   | C/C++              | C#                 | Python             | Java               | JavaScript         |
| --------- | ------------------ | ------------------ | ------------------ | ------------------ | ------------------ |
| Leap API  | :white_check_mark: | :white_check_mark: | :white_check_mark: | :white_check_mark: | :white_check_mark: |
| LeapC API | :white_check_mark: | :x:                | :x:                | :x:                | :x:                |

## Game engine supports

I haven't looked to find if the Unity and Unreal plugins were still publicly available for Leap Motion 2.x and Leap Motion 3.x. This table is incomplete and shouldn't be trusted.

Looking for the latest plugins themselves? The headers of the table have public links to them.

| Version         | [Unity]            | [Unreal]           |
| --------------- | ------------------ | ------------------ |
| Leap Motion 2.x | :interrobang:      | :interrobang:      |
| Leap Motion 3.x | :interrobang:      | :interrobang:      |
| Leap Motion 4.x | :white_check_mark: | :white_check_mark: |
| Ultraleap 5.2+  | :white_check_mark: | :white_check_mark: |

---

[¹]: #1
<a name=1>¹</a>
Not available on MacOS

[²]: #2
<a name=2>²</a>
Meta headsets are not supported

[³]: #3
<a name=3>³</a>
Not available on Android

[Unity]: https://github.com/ultraleap/UnityPlugin/
[Unreal]: https://github.com/ultraleap/UnrealPlugin